//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormMain.h"
#include "FormOption.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FrameSnoopSessionList"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
void TMainForm::initializeControl()
{
  SnoopSessionListFrame1->Align = alClient;
  pnlLeft->Align = alClient;

  arpSpoof.owner = this;
  arpSpoof.onCapture = _arpSpoof_OnCapture;
}

void TMainForm::finalizeControl()
{
}

void TMainForm::loadControl()
{
  // WindowPos
  if (!global->loadWindowPos(Handle, "MainForm"))
  {
    Left = 0;
    Top = 0;
  }

  // SessionListFrame
  global->loadSessionListFrame(SnoopSessionListFrame1);

  // SnoopARPSpoof
  global->loadARPSpoof(&arpSpoof);
  SnoopNetInfo netInfo;
  global->loadNetInfo(&netInfo);
  SnoopSessionListFrame1->loadControl(&arpSpoof.sessionList, ip_to_str(netInfo.gateway));

  // Other
  VDXML* xml = global->xmlFile.root->gotoChild("MainForm");
  chkRelay->Checked = xml->getBool("Relay", true);
}

void TMainForm::saveControl()
{
  // WindowPos
  global->saveWindowPos(Handle, "MainForm");

  // SessionListFrame
  global->saveSessionListFrame(SnoopSessionListFrame1);

  // SnoopARPSpoof
  SnoopNetInfo netInfo;
  global->loadNetInfo(&netInfo);
  SnoopSessionListFrame1->loadControl(&arpSpoof.sessionList, ip_to_str(netInfo.gateway));
  global->saveARPSpoof(&arpSpoof);

  // Other
  VDXML* xml = global->xmlFile.root->gotoChild("MainForm");
  xml->setBool("Relay", chkRelay->Checked);
}

void TMainForm::setControl()
{
  bool scanning = SnoopSessionListFrame1->SnoopHostListFrame1->active();
  bool active = arpSpoof.active();
  btnOpen->Enabled = !scanning && !active;
  btnClose->Enabled = !scanning && active;
}

void TMainForm::_arpSpoof_OnCapture(
    SnoopCapture* capture,
    SnoopPacket*  packet)
{
  TMainForm* MainForm = (TMainForm*)capture->owner;
  packet->relay = MainForm->chkRelay->Checked;

  TStatusPanel* Panel = MainForm->StatusBar1->Panels->Items[0];
  Panel->Text = StrToInt(Panel->Text) + 1;
}

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  initializeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
  int count = SnoopSessionListFrame1->SnoopHostListFrame1->lvHostList->Items->Count;
  if (count == 0)
    SnoopSessionListFrame1->SnoopHostListFrame1->btnScan->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  saveControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  finalizeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnOpenClick(TObject *Sender)
{
  global->loadARPSpoof(&arpSpoof);
  SnoopNetInfo netInfo;
  global->loadNetInfo(&netInfo);
  SnoopSessionListFrame1->loadControl(&arpSpoof.sessionList, ip_to_str(netInfo.gateway));
  if (!arpSpoof.open())
  {
    Application->MessageBoxA(arpSpoof.error.msg, "Error", MB_ICONERROR);
  }
  MainForm->StatusBar1->Panels->Items[0]->Text= "0";
  setControl();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnCloseClick(TObject *Sender)
{
  arpSpoof.close();
  setControl(); 
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnOptionClick(TObject *Sender)
{
  if (OptionForm == NULL)
    OptionForm = new TOptionForm(Application);
  OptionForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SnoopHostListFrame1btnScanClick(TObject *Sender)
{
  SnoopARPSpoof arpSpoof;
  global->loadARPSpoof(&arpSpoof);
  SnoopNetInfo netInfo;
  global->loadNetInfo(&netInfo);

  SnoopSessionListFrame1->SnoopHostListFrame1->scan(
    arpSpoof.adapterIndex,
    netInfo.startIP,
    netInfo.endIP
  );
  setControl();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SnoopHostListFrame1tmrCloseTimer(TObject *Sender)
{
  SnoopSessionListFrame1->SnoopHostListFrame1->tmrCloseTimer(Sender);
  setControl();  
}
//---------------------------------------------------------------------------

