#ifndef GlobalH
#define GlobalH

#include "VDXMLFile.h"
#include "SnoopARPSpoof.h"
#include "SnoopNetInfo.h"
#include "FrameSnoopSessionList.h"

class Global
{
public:
  VDXMLFile xmlFile;
public:
  Global();
  virtual ~Global();
  void load();
  void save();
  bool isOk();
public:
  // Log
  void initializeLog();
  void finalizeLog();

  // WindowPos
  bool loadWindowPos(HWND hwnd, char* name);
  bool saveWindowPos(HWND hwnd, char* name);

  // ARPSpoof
  void loadARPSpoof(SnoopARPSpoof* arpSpoof);
  void saveARPSpoof(SnoopARPSpoof* arpSpoof);
  // ----- gilgil temp 2010.12.10 -----
  /*
  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  int getAdapterIndex();
  void setAdapterIndex(int value);
  */
  // ----------------------------------

  // NetInfo
  void loadNetInfo(SnoopNetInfo* netInfo);
  void saveNetInfo(SnoopNetInfo* netInfo);

  // SessionListFrame
  void loadSessionListFrame(TSnoopSessionListFrame* frame);
  void saveSessionListFrame(TSnoopSessionListFrame* frame);
};

extern Global* global;

#endif  GlobalH
