#ifndef GlobalH
#define GlobalH

#include "VDXMLFile.h"
#include "Snoop.h"
#include "SnoopNetInfo.h"
#include "FrameSnoopHostList.h"

class Global
{
protected:
  VDXMLFile xmlFile;
public:
  Global();
  virtual ~Global();
  void load();
  void save();
  bool isOk();
public:
  // Log
  void initializeLog();
  void finalizeLog();

  // WindowPos
  bool loadWindowPos(HWND hwnd, char* name);
  bool saveWindowPos(HWND hwnd, char* name);

  // Adapter
  SnoopAdapter adapter;
  void loadAdapter(SnoopAdapter* adapter);
  void saveAdapter(SnoopAdapter* adapter);
  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  int getAdapterIndex();
  void setAdapterIndex(int value);

  // NetInfo
  SnoopNetInfo netInfo;
  void loadNetInfo(SnoopNetInfo* netInfo);
  void saveNetInfo(SnoopNetInfo* netInfo);

  // HostListFrame
  void loadHostListFrame(TSnoopHostListFrame* frame);
  void saveHostListFrame(TSnoopHostListFrame* frame);
};

extern Global* global;

#endif  GlobalH
