//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormMain.h"
#include "FormHostList.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
void TMainForm::initializeControl()
{
}

void TMainForm::finalizeControl()
{
}

void TMainForm::loadControl()
{
  // WindowPos
  if (!global->loadWindowPos(Handle, "MainForm"))
  {
    Left = 0;
    Top = 0;
  }

  // Controls
  VDXML* xml = global->xmlFile.root->gotoChild("Controls");
  edDestination->Text = xml->getStr("destination", "").c_str();
  edSource->Text = xml->getStr("source", "").c_str();
  edProtocol->Text = xml->getStr("protocol", "0x0806").c_str();
  edHardwareType->Text = xml->getStr("hardwareType", "1").c_str();
  edProtocolType->Text = xml->getStr("protocolType", "2048").c_str();
  edHLen->Text = xml->getStr("pLen", "6").c_str();
  edPLen->Text = xml->getStr("hLen", "4").c_str();
  cbxOperation->ItemIndex = xml->getInt("operation", -1);
  edSenderHA->Text = xml->getStr("senderHA", "").c_str();
  edSenderIP->Text = xml->getStr("senderIP", "").c_str();
  edTargetHA->Text = xml->getStr("targetHA", "").c_str();
  edTargetIP->Text = xml->getStr("targetIP", "").c_str();
}

void TMainForm::saveControl()
{
  // WindowPos
  global->saveWindowPos(Handle, "MainForm");

  // Controls
  VDXML* xml = global->xmlFile.root->gotoChild("Controls");
  xml->setStr("destination", edDestination->Text.c_str());
  xml->setStr("source", edSource->Text.c_str());
  xml->setStr("protocol", edProtocol->Text.c_str());
  xml->setStr("hardwareType", edHardwareType->Text.c_str());
  xml->setStr("protocolType", edProtocolType->Text.c_str());
  xml->setStr("pLen", edHLen->Text.c_str());
  xml->setStr("hLen", edPLen->Text.c_str());
  xml->setInt("operation", cbxOperation->ItemIndex);
  xml->setStr("senderHA", edSenderHA->Text.c_str());
  xml->setStr("senderIP", edSenderIP->Text.c_str());
  xml->setStr("targetHA", edTargetHA->Text.c_str());
  xml->setStr("targetIP", edTargetIP->Text.c_str());
}

void TMainForm::setControl()
{
}

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  initializeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  saveControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  finalizeControl();  
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::sbtDestinationClick(TObject *Sender)
{
  HostListForm->ShowModal();
  if (HostListForm->Tag == mrOk)
  {
    TListItem* ListItem = HostListForm->SnoopHostListFrame1->lvHostList->Selected;
    if (ListItem == NULL) return;
    edDestination->Text = ListItem->SubItems->Strings[1];
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::sbtSourceClick(TObject *Sender)
{
  HostListForm->ShowModal();
  if (HostListForm->Tag == mrOk)
  {
    TListItem* ListItem = HostListForm->SnoopHostListFrame1->lvHostList->Selected;
    if (ListItem == NULL) return;
    edSource->Text = ListItem->SubItems->Strings[1];
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::sbtSenderHAClick(TObject *Sender)
{
  HostListForm->ShowModal();
  if (HostListForm->Tag == mrOk)
  {
    TListItem* ListItem = HostListForm->SnoopHostListFrame1->lvHostList->Selected;
    if (ListItem == NULL) return;
    edSenderHA->Text = ListItem->SubItems->Strings[1];
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::sbtSenderIPClick(TObject *Sender)
{
  HostListForm->ShowModal();
  if (HostListForm->Tag == mrOk)
  {
    TListItem* ListItem = HostListForm->SnoopHostListFrame1->lvHostList->Selected;
    if (ListItem == NULL) return;
    edSenderIP->Text = ListItem->SubItems->Strings[0];
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::sbtTargetHAClick(TObject *Sender)
{
  HostListForm->ShowModal();
  if (HostListForm->Tag == mrOk)
  {
    TListItem* ListItem = HostListForm->SnoopHostListFrame1->lvHostList->Selected;
    if (ListItem == NULL) return;
    edTargetHA->Text = ListItem->SubItems->Strings[1];
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::sbtTargetIPClick(TObject *Sender)
{
  HostListForm->ShowModal();
  if (HostListForm->Tag == mrOk)
  {
    TListItem* ListItem = HostListForm->SnoopHostListFrame1->lvHostList->Selected;
    if (ListItem == NULL) return;
    edTargetIP->Text = ListItem->SubItems->Strings[0];
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnSendClick(TObject *Sender)
{
  ETH_HDR ethHdr;
  ARP_HDR arpHdr;


  ethHdr.ether_dhost = edDestination->Text.c_str();
  ethHdr.ether_shost = edSource->Text.c_str();
  ethHdr.ether_type   = htons(StrToInt(edProtocol->Text));

  arpHdr.ar_hrd = htons(StrToInt(edHardwareType->Text));
  arpHdr.ar_pro = htons(StrToInt(edProtocolType->Text));
  arpHdr.ar_hln = StrToInt(edHLen->Text);
  arpHdr.ar_pln = StrToInt(edPLen->Text);
  arpHdr.ar_op = htons(cbxOperation->ItemIndex);
  arpHdr.ar_sa = edSenderHA->Text.c_str();
  arpHdr.ar_si = htonl(str_to_ip(edSenderIP->Text.c_str()));
  arpHdr.ar_ta = edTargetHA->Text.c_str();
  arpHdr.ar_ti = htonl(str_to_ip(edTargetIP->Text.c_str()));

  SnoopAdapter adapter;
  adapter.autoCapture = false;
  adapter.adapterIndex = global->adapterIndex;
  if (!adapter.open())
  {
    Application->MessageBox(adapter.error.msg, "Open Error", MB_ICONERROR);
    return;
  }
  int res = snoopSendARP(adapter.m_pcap, &ethHdr, &arpHdr);
  if (res < 0)
  {
    Application->MessageBox(adapter.error.msg, "Send Error", MB_ICONERROR);
  }
  adapter.close();
}


//---------------------------------------------------------------------------

