#include <conio.h> // for _getch() // gilgil temp

#include "SnoopARPRecoverList.h"
#include "Global.h"

SnoopARPRecoverList* recoverList = NULL;

void usage()
{
  printf("arprecover mady by gilgil\n");
}

void tcpServer_onRun(void* owner, void* sender, VDTCPSessionThread* thread)
{
  VDTCPSession* tcpSession = thread->tcpSession;
  printf("connected    %s:%d\n", tcpSession->getRemoteIP().c_str(), tcpSession->getRemotePort());

  static const int BUF_SIZE = 4096;
  while (true)
  {
    char buf[BUF_SIZE + 1];

    //
    // Read SnoopARPSpoof xml format option
    //
    int res = tcpSession->read(buf, BUF_SIZE);
    if (res == VDERR_FAIL) break;
    buf[res] = '\0';

    //
    // Parse SnoopARPSpoof xml format option
    //
    VDXML* xml = new VDXML;
    bool parse = xml->parse(buf);
    LOG_DEBUG("[arprecover.cpp] tcpServer_onRun xml->parse() return %d\n%s", (int)parse, buf);
    if (!parse)
    {
      tcpSession->write("xml parse return false", 22);
      break;
    }

    //
    // Get adapterIndex from xml format option
    //
    int adapterIndex = SNOOP_INVALID_ADAPTER_INDEX;
    SnoopARPSpoof arpSpoof;
    arpSpoof.load(xml);
    adapterIndex = arpSpoof.adapterIndex;
    LOG_DEBUG("[arprecover.cpp] tcpServer_onRun adapterIndex=%d", adapterIndex);
    if (adapterIndex == SNOOP_INVALID_ADAPTER_INDEX)
    {
      tcpSession->write("invalid adapter list", 20);
      break;
    }

    SnoopARPRecover* recover = recoverList->find(adapterIndex);
    if (recover == NULL)
    {
      recover =  new SnoopARPRecover;
      recoverList->add(recover);
    }
  }
  printf("disconnected %s:%d\n", tcpSession->getRemoteIP().c_str(), tcpSession->getRemotePort());
  tcpSession->close();
}

int main()
{
  global = new Global;
  recoverList = new SnoopARPRecoverList;

  VDTCPServer tcpServer;
  tcpServer.onRun = tcpServer_onRun;
  tcpServer.localHost = "127.0.0.1";
  tcpServer.port = SNOOP_ARP_RECOVER_DEFAULT_PORT;
  global->loadTCPServer(&tcpServer);

  SnoopARPRecover arpRecover;
  global->loadARPRecover(&arpRecover);

  SetLastError(NO_ERROR);
#ifdef UNICODE
  HANDLE mutex = CreateMutex(NULL, TRUE, L"arpspoofrecover");
#else
  HANDLE mutex = CreateMutex(NULL, TRUE, "arpspoofrecover");
#endif
  DWORD error = GetLastError();
  LOG_DEBUG("[%s:%d] %s mutex = %p error=%u\n", __FILENAME__, __LINE__, __FUNCTION__, mutex, error);
  if (error == ERROR_ALREADY_EXISTS)
  {
    printf("already running\n");
    //
    // parameter must be processed // gilgil temp 2010.11.24
    //
    goto _end;
  }

  if (!tcpServer.open())
  {
    printf("%s\n", tcpServer.error.msg);
    return 0;
  }

  printf("press any key to close\n");
  _getch();

_end:
  tcpServer.close();
  global->saveTCPServer(&tcpServer);
  global->saveARPRecover(&arpRecover);

  if (mutex != (HANDLE)0) CloseHandle(mutex);

  delete recoverList;
  delete global;

  return 0;
}
