#include "sc.h"

#pragma comment (lib, "wpcap.lib")

static VDInterfaceManager* g_mgr     = NULL;
static int                 g_ref_cnt = 0;

ISnoopCapture* createSnoopCapture(char* xmlFileName)
{
  if (g_ref_cnt++ == 0)
  {
    g_mgr = new VDInterfaceManager("sc.dll");
  }
  if (g_mgr == NULL) return NULL;
  ISnoopCapture* res = (ISnoopCapture*)g_mgr->createInterface(xmlFileName);
  return res;
}

void deleteSnoopCapture(ISnoopCapture* snoopCapture)
{
  if (g_mgr == NULL) return;
  g_mgr->deleteInterface(snoopCapture);
  if (--g_ref_cnt == 0)
  {
    delete g_mgr;
	g_mgr = NULL;
  }
}

class SnoopCaptureDLLHangFix
{
public:
  SnoopCaptureDLLHangFix()
  {
    //
    // strange to say, if pcap_findalldevs_ex is called in dll file, it hangs.
	// so call pcap_findalldevs_ex explicitly in application(exe file)
	// for the first time when application is launched.
    //
    pcap_if_t* allDevs;
	pcap_findalldevs_ex("rpcap://", NULL, &allDevs, NULL);    
  };
  virtual ~SnoopCaptureDLLHangFix()
  {
  }
};

SnoopCaptureDLLHangFix fix;