// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.vdream.co.kr
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SCH
#define SCH

#define WPCAP
#define HAVE_REMOTE
#include "pcap.h"
#include "VDInterface.h"

// ----------------------------------------------------------------------------
// ISnoopCaptureEvent
// ----------------------------------------------------------------------------
class ISnoopCapture;
typedef void (*ISnoopCapture_OnCapture)(ISnoopCapture* capture, struct pcap_pkthdr* header, char* packet);

// ----------------------------------------------------------------------------
// ISnoopCapture
// ----------------------------------------------------------------------------
class ISnoopCapture : public IVDInterface
{
public:
  virtual char* error() = 0;
  virtual bool  open() = 0;
  virtual bool  close() = 0;
  virtual int   write(char* buf, int size) = 0;
  virtual int   captureType() = 0;
  virtual int   relay(struct pcap_pkthdr* header, char* packet) = 0;
  virtual void  setCapture(ISnoopCapture_OnCapture onCapture) = 0;
  virtual bool  load(char* xmlFileName) = 0;
  virtual bool  save(char* xmlFileName) = 0;
};

ISnoopCapture* createSnoopCapture(char* xmlFileName);
void           deleteSnoopCapture(ISnoopCapture* snoopCapture);

#endif // SCH
