// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.vdream.co.kr
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SCImplH
#define SCImplH

#include "SnoopCaptureFactory.h"
#include "sc.h"

// ----------------------------------------------------------------------------
// SnoopCaptureImpl
// ----------------------------------------------------------------------------
class SnoopCaptureImpl : public ISnoopCapture
{
public:
  SnoopCaptureImpl(void* param);
  ~SnoopCaptureImpl();

protected:
  SnoopCapture* m_capture;
  static void _onCapture(SnoopCapture* capture, SnoopPacket*  packet);
  ISnoopCapture_OnCapture onCapture;
public:
  virtual char* error();
  virtual bool open();
  virtual bool close();
  virtual int  write(char* buf, int size);
  virtual int  captureType();
  virtual int  relay(struct pcap_pkthdr* header, char* packet);
  virtual void setCapture(ISnoopCapture_OnCapture onCapture);
  virtual bool load(char* xmlFileName);
  virtual bool save(char* xmlFileName);
};

#endif // SCImplH