#include "stdafx.h"
#include "sc.h"
#include "sc_impl.h"

#ifdef _MANAGED
#pragma managed(push, off)
#endif

// ----------------------------------------------------------------------------
// Exported Functions
// ----------------------------------------------------------------------------
VDINTERFACE_API IVDInterface* create_interface(void* param)
{
  return new SnoopCaptureImpl(param);
}

VDINTERFACE_API IVDInterface* get_interface(void *param)
{
  return NULL;
}

VDINTERFACE_API void delete_interface(IVDInterface* intf)
{
  SnoopCaptureImpl* capture = (SnoopCaptureImpl*)intf;
  delete capture;
}

// ----------------------------------------------------------------------------
// DllMain
// ----------------------------------------------------------------------------
BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
  switch (ul_reason_for_call)
  {
    case DLL_PROCESS_ATTACH:
	{
	  LOG_INFO("[sc_main.cpp] DLL_PROCESS_ATTACH %s %s", __TIME__, __DATE__);
	  break;
	}
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
	  LOG_INFO("[sc_main.cpp] DLL_PROCESS_DETACH %s %s", __TIME__, __DATE__);
	  break;
  }
  return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif
