#include <stdio.h>
#include <conio.h>

#include "SnoopAdapter.h"

void adapter_OnClose(void* owner, void* sender)
{
  SnoopAdapter* adapter = (SnoopAdapter*)sender;
  printf("%s\n", adapter->error.msg);
}

void adapter_OnCapture(SnoopCapture* capture, SnoopPacket* packet)
{
  printf("%d bytes captured\n", packet->pktHdr->caplen);
}

void main()
{
  SnoopAdapter adapter;
  adapter.onClose   = adapter_OnClose;
  adapter.onCapture = adapter_OnCapture;
  adapter.adapterIndex = SnoopAdapter::getBestAdapterIndex();

  if (!adapter.open())
  {
    printf("error=%s\n", adapter.error.msg);
    return;
  }

  printf("Press any key to close\n");
  _getch();
  adapter.close();
}