//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FrameSnoop.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSnoopFrame *SnoopFrame;
//---------------------------------------------------------------------------
void TSnoopFrame::initializeControl()
{
  SnoopETH snoopETH;

  cbxAdapter->Items->Clear();
  int count = snoopGetAdapterCount();
  for (int i = 0; i < count; i++)
  {
    SnoopAdapterInfo* adapterInfo = snoopGetAdapterInfo(i);
    cbxAdapter->Items->Add(adapterInfo->description.c_str());
  }
#ifndef SNOOP_THREAD_SAFE_SUPPORT
  chkThreadSafe->Visible = false;
#endif SNOOP_THREAD_SAFE_SUPPORT
}

void TSnoopFrame::finalizeControl()
{
}

void TSnoopFrame::loadControl(SnoopAdapter* adapter)
{
  cbxAdapter->ItemIndex = adapter->adapterIndex;
  edFilter->Text = adapter->filter.c_str();
  edSnapLen->Text = adapter->snapLen;
  edFlags->Text = adapter->flags;
  edReadTimeout->Text = adapter->readTimeout;
  chkAutoCapture->Checked = adapter->autoCapture;
#ifdef SNOOP_THREAD_SAFE_SUPPORT
  chkThreadSafe->Checked = adapter->threadSafe;
#endif SNOOP_THREAD_SAFE_SUPPORT
}

void TSnoopFrame::saveControl(SnoopAdapter* adapter)
{
  adapter->adapterIndex = cbxAdapter->ItemIndex;
  adapter->filter = edFilter->Text.c_str();
  adapter->snapLen = StrToInt(edSnapLen->Text);
  adapter->flags = StrToInt(edFlags->Text);
  adapter->readTimeout = StrToInt(edReadTimeout->Text);
  adapter->autoCapture = chkAutoCapture->Checked;
#ifdef SNOOP_THREAD_SAFE_SUPPORT
  adapter->threadSafe = chkThreadSafe->Checked;
#endif SNOOP_THREAD_SAFE_SUPPORT
}

void TSnoopFrame::setControl()
{
}

bool TSnoopFrame::detectAdapter()
{
  int adapterIndex = SnoopAdapter::getBestAdapterIndex();
  cbxAdapter->ItemIndex = adapterIndex;

  if (adapterIndex != -1)
  {
    SnoopAdapterInfo* adapterInfo = snoopGetAdapterInfo(adapterIndex);
    string description = adapterInfo->description;
    Application->MessageBox(
      format("Appropriate Adapter is\r\n%s.", description.c_str()).c_str(),
      "Confirm",
      MB_ICONINFORMATION);
    return true;
  }
  Application->MessageBox("No Adapter is found", "Error", MB_ICONWARNING);
  return false;
}

//---------------------------------------------------------------------------
__fastcall TSnoopFrame::TSnoopFrame(TComponent* Owner)
  : TFrame(Owner)
{
  initializeControl();
  SnoopAdapter adapter;
  loadControl(&adapter);
}
//---------------------------------------------------------------------------
__fastcall TSnoopFrame::~TSnoopFrame()
{
  finalizeControl();
}
//---------------------------------------------------------------------------
void __fastcall TSnoopFrame::Loaded()
{
  ParentColor = true;
}
//---------------------------------------------------------------------------

void __fastcall TSnoopFrame::btnAutoCheckClick(TObject *Sender)
{
  detectAdapter();
}
//---------------------------------------------------------------------------


