//---------------------------------------------------------------------------

#ifndef FrameSnoopHostListH
#define FrameSnoopHostListH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#include "VDXML.h"
#include "SnoopFindHost.h"
//---------------------------------------------------------------------------
#define WM_MYCLOSE (WM_USER + 10)

//---------------------------------------------------------------------------
// FindHostNameThread
//---------------------------------------------------------------------------
class TSnoopHostListFrame;
class FindHostNameThread : public VDThread
{
protected:
  TSnoopHostListFrame* owner;
  string ip;
public:
  FindHostNameThread(TSnoopHostListFrame* owner);
  virtual ~FindHostNameThread();
  bool open(string ip);
  bool close(bool wait = true);
  virtual void run();
  static void show(VDThread* thread, void* user);
};

//---------------------------------------------------------------------------
// FindHostNameThreadList
//---------------------------------------------------------------------------
typedef VDPList<FindHostNameThread*> FindHostNameThreadList;

//---------------------------------------------------------------------------
// SendARPRequestAllThread
//---------------------------------------------------------------------------
class SendARPRequestAllThread : public VDThread
{
protected:
  TSnoopHostListFrame* owner;
public:
  SendARPRequestAllThread(TSnoopHostListFrame* owner);
  virtual ~SendARPRequestAllThread();
  virtual void run();
};

class TSnoopHostListFrame : public TFrame, IVDXMLable
{
__published:	// IDE-managed Components
  TTimer *tmrClose;
  TPopupMenu *pmBasic;
  TMenuItem *miSelectAll;
  TMenuItem *miSelectNone;
  TMenuItem *miSelectReverse;
  TPanel *pnlBasicTop;
  TButton *btnScan;
  TButton *btnClear;
  TListView *lvHostList;
  void __fastcall tmrCloseTimer(TObject *Sender);
  void __fastcall btnScanClick(TObject *Sender);
  void __fastcall btnClearClick(TObject *Sender);
  void __fastcall miSelectAllClick(TObject *Sender);
  void __fastcall miSelectNoneClick(TObject *Sender);
  void __fastcall miSelectReverseClick(TObject *Sender);
  void __fastcall lvHostListColumnClick(TObject *Sender, TListColumn *Column);
  void __fastcall lvHostListCompare(TObject *Sender, TListItem *Item1,
          TListItem *Item2, int Data, int &Compare);
private:	// User declarations
public:		// User declarations
  __fastcall TSnoopHostListFrame(TComponent* Owner);
  virtual __fastcall ~TSnoopHostListFrame();
  void virtual __fastcall Loaded();
  virtual void __fastcall Dispatch(void *Message);
protected:
  friend class SendARPRequestAllThread;
  SnoopFindHost findHost;
  FindHostNameThreadList threadList;
  SendARPRequestAllThread* sendARPRequestAllThread;
public:
  bool addSelf;

  void initializeControl();
  void finalizeControl();
  void loadControl(SnoopHostList* hostList);
  void saveControl(SnoopHostList* hostList);
  void setControl();

public:
  bool active();
  void scan(int adapterIndex, IP startIP, IP endIP);
  void scan(int adapterIndex, string startIP, string endIP);

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);

protected:
  static void _findHost_OnCapture(
    SnoopFindHost* snoopFindHost,
    IP*            ip,
    MAC*           mac);
  void findHost_OnCapture(
    SnoopFindHost* snoopFindHost,
    IP*            ip,
    MAC*           mac);
public:
  TListItem* findListItem(string ip);
};
//---------------------------------------------------------------------------
extern PACKAGE TSnoopHostListFrame *SnoopHostListFrame;
//---------------------------------------------------------------------------
#endif
