// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopAdapterH
#define SnoopAdapterH

#include "SnoopPcap.h"
#include "SnoopAdapterInfo.h"

// ----------------------------------------------------------------------------
// SnoopAdapter
// ----------------------------------------------------------------------------
class SnoopAdapter : public SnoopPcap
{
public:
  SnoopAdapter(void* owner = NULL);
  virtual ~SnoopAdapter();

protected:
  virtual bool doOpen();
  virtual bool doClose();

protected:
  int m_adapterIndex;
public:
  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  int          getAdapterIndex() { return m_adapterIndex; }
  virtual void setAdapterIndex(int value);

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);

public:
  static int getBestAdapterIndex(string host = "");
};

#endif  SnoopAdapterH