// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopAdapterInfoH
#define SnoopAdapterInfoH

#include "Snoop.h"

// ----------------------------------------------------------------------------
// SnoopAdapterInfo
// ----------------------------------------------------------------------------
class SnoopAdapterInfo : public IVDXMLable
{
  friend class SnoopAdaptersInfo;
  friend class VDPList<SnoopAdapterInfo*>;
  friend class SnoopRemote;

protected:
  SnoopAdapterInfo();
  virtual ~SnoopAdapterInfo();

public:
  int              index;
  string           name;
  string           description;

  pcap_if_t*       dev;
  PIP_ADAPTER_INFO ipAdapterInfo;

public:
  bool operator == (SnoopAdapterInfo& rhs);
  bool operator != (SnoopAdapterInfo& rhs);

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

// ----------------------------------------------------------------------------
// SnoopAdaptersInfo
// ----------------------------------------------------------------------------
class SnoopAdaptersInfo :
  public IVDXMLable,
  public VDClassInitialize<SnoopAdaptersInfo>
{
  friend int               snoopGetAdapterCount();
  friend SnoopAdapterInfo* snoopGetAdapterInfo(int index);
  friend class SnoopRemote;

protected:
  SnoopAdaptersInfo();
  virtual ~SnoopAdaptersInfo();

protected:
  VDPList<SnoopAdapterInfo*> items;

public: // gilgil temp 2009.09.091 protected:
  pcap_if_t*       allDevs;
  PIP_ADAPTER_INFO allIPAdaptersInfo;

  void initialize();
  void finalize();

public:
  bool operator == (SnoopAdaptersInfo& rhs);
  bool operator != (SnoopAdaptersInfo& rhs);

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);

  //
  // Static
  //
protected:
  static SnoopAdaptersInfo* g_adaptersInfo;
private:
  friend class VDClassInitialize<SnoopAdaptersInfo>;
  static void  doClassInitialize();
  static void  doClassFinalize();
};

// ----------------------------------------------------------------------------
// Functions
// ----------------------------------------------------------------------------
int               snoopGetAdapterCount();
SnoopAdapterInfo* snoopGetAdapterInfo(int index);

#endif  SnoopAdapterInfoH