// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopCaptureH
#define SnoopCaptureH

#include "VDBasicObject.h"
#include "VDThread.h"
#include "Snoop.h"

// ----------------------------------------------------------------------------
// SnoopCapture event
// ----------------------------------------------------------------------------
class SnoopCapture;
typedef void (*SnoopCapture_OnCapture)(SnoopCapture* capture, SnoopPacket* packet);

// ----------------------------------------------------------------------------
// SnoopCapture
// ----------------------------------------------------------------------------
/// Base class of all capture class
class SnoopCapture : public VDBasicObject, protected IVDRunnable
{
public:
  SnoopCapture(void* owner = NULL);
  virtual ~SnoopCapture();

protected:
  virtual bool doOpen();
  virtual bool doClose();

public:
  virtual int read(SnoopPacket* packet);
  virtual int write(char* buf, int size);

public:
  virtual int captureType() { return SCT_NONE; }
  virtual int relay(SnoopPacket* packet);

  //
  // Properties
  //
public:
  bool         autoCapture;
#ifdef SNOOP_THREAD_SAFE_SUPPORT
  bool         threadSafe;
#endif // SNOOP_THREAD_SAFE_SUPPORT
  VDRunThread* thread;
protected:
  virtual void run();
  static void _OnCaptureCB(VDThread* thread, void* user);

public:
  SnoopCapture_OnCapture onCapture;

protected:
  SnoopPacket packet;

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  SnoopCaptureH