// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopCommonH
#define SnoopCommonH

#include <winsock2.h>
#include <windows.h>
#include <Iphlpapi.h>

#define  WPCAP
#define  HAVE_REMOTE
#include "pcap.h"

// ----------------------------------------------------------------------------
// Version
// ----------------------------------------------------------------------------
#define SNOOP_VERSION MAKELONG(MAKEWORD(5,1),MAKEWORD(8,27)) // 5.1.7.16

// ----------------------------------------------------------------------------
// Constant
// ----------------------------------------------------------------------------
#define SNOOP_DEFAULT_READTIMEOUT      1
#define SNOOP_DEFAULT_SNAPLEN          1600
#define SNOOP_DEFAULT_TIMEOUT          5000
#define SNOOP_INVALID_ADAPTER_INDEX    -1

// ----------------------------------------------------------------------------
// SNOOP CAPTURE TYPE
// ----------------------------------------------------------------------------
#define SCT_NONE        0
#define SCT_IN_PATH     1
#define SCT_OUT_OF_PATH 2

#include "SnoopConfig.h"

#ifdef SNOOP_USE_VDREAM

// ----------------------------------------------------------------------------
// Link Library
// ----------------------------------------------------------------------------
#ifdef _DEBUG
#pragma comment(lib, "SnoopD.lib")
#else  _DEBUG
#pragma comment(lib, "Snoop.lib")
#endif _DEBUG
#pragma comment(lib, "wpcap.lib")
#pragma comment(lib, "Iphlpapi.lib")

#include "VDCommon.h"
#include "VDNet.h"
#include "VDDesign.h"
#include "VDError.h"
#include "VDDelphi.h"
#include "VDLog.h"
#include "VDXML.h"

// ----------------------------------------------------------------------------
// SnoopError
// ----------------------------------------------------------------------------
DECLARE_ERROR_CLASS(SnoopError)

#endif SNOOP_USE_VDREAM

#endif  SnoopCommonH