#include "SnoopETH.h"

// ----------------------------------------------------------------------------
// SnoopETH
// ----------------------------------------------------------------------------
bool SnoopETH::is(ETH_HDR* ethHdr, UINT16 etherType, void** networkHdr)
{
  if (ntohs(ethHdr->ether_type) != etherType)
    return false;
  if (networkHdr != NULL)
    *networkHdr = (void*)((char*)(ethHdr) + sizeof(ETH_HDR));
  return true;
}

bool SnoopETH::isIP(ETH_HDR* ethHdr, IP_HDR** ipHdr)
{
  if (ethHdr->ether_type != ((WORD)LOBYTE(ETHERTYPE_IP) << 8 | HIBYTE(ETHERTYPE_IP)))
    return false;
  if (ipHdr != NULL)
    *ipHdr = (IP_HDR*)((char*)(ethHdr) + sizeof(ETH_HDR));
  return true;
}

bool SnoopETH::isARP(ETH_HDR* ethHdr, ARP_HDR** arpHdr)
{
  if (ethHdr->ether_type != ((WORD)LOBYTE(ETHERTYPE_ARP) << 8 | HIBYTE(ETHERTYPE_ARP)))
    return false;
  if (arpHdr != NULL)
    *arpHdr = (ARP_HDR*)((char*)(ethHdr) + sizeof(ETH_HDR));
  return true;
}

bool SnoopETH::parse(SnoopPacket* packet)
{
  packet->ethHdr   = (ETH_HDR*)packet->pktData;
  packet->linkType = LINKTYPE_ETH;
  return true;
}
