// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopFindHostH
#define SnoopFindHostH

#include "SnoopAdapter.h"
#include "SnoopNetInfo.h"
#include "SnoopHostList.h"
#include "SnoopETH.h"
#include "SnoopARP.h"

// ----------------------------------------------------------------------------
// SnoopFindHost event
// ----------------------------------------------------------------------------
class SnoopFindHost;
typedef void (*SnoopFindHost_OnCapture)(
  SnoopFindHost* snoopFindHost,
  IP*            ip,
  MAC*           mac);

// ----------------------------------------------------------------------------
// SnoopFindHost
// ----------------------------------------------------------------------------
class SnoopFindHost : public SnoopAdapter
{
protected:
  virtual void run();
  static void _OnCaptureCB(VDThread * thread, void* user);
public:
  SnoopFindHost(void* owner = NULL);
  virtual ~SnoopFindHost();
public:
  SnoopFindHost_OnCapture onCapture;
public:
  int readIPAndMAC(IP* ip, MAC* mac);
protected:
  SnoopNetInfo netInfo;
  int sendARPRequest(IP ip);
public:
  SnoopHostList hostList;
public:
  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  virtual void setAdapterIndex(int value);
protected:
  virtual bool doOpen();
  virtual bool doClose();
public:
  bool sendARPRequestAll();
  bool isFoundAll();
  void logUnfoundHost(VDLog* log = NULL);
  bool scan(DWORD timeout = SNOOP_DEFAULT_TIMEOUT);
protected:
  DWORD lastSendTick;
public:
  int  scanInterval;
  int  sendInterval;
public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  SnoopFindHostH