// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopHostListH
#define SnoopHostListH

#include "VDXML.h"
#include "Snoop.h"

// ----------------------------------------------------------------------------
// SnoopHost
// ----------------------------------------------------------------------------
class SnoopHost : public IVDXMLable
{
public:
  IP     ip;
  MAC    mac;
  string name;
public:
  SnoopHost();
  virtual ~SnoopHost();
  void clear();
public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

// ----------------------------------------------------------------------------
// SnoopHostList
// ----------------------------------------------------------------------------
class SnoopHostList : public VDPList<SnoopHost*>, public IVDXMLable
{
public:
  SnoopHostList();
  virtual ~SnoopHostList();
public:
  SnoopHost* add(IP ip = 0, MAC mac = snoopCleanMac, string name = "");
  SnoopHost* add(string ip);
  SnoopHost* findByIP(IP ip);
public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  SnoopHostListH