// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopIPH
#define SnoopIPH

#include "SnoopETH.h"

// ----- gilgil temp 2010.11.30 -----
/*
// ----------------------------------------------------------------------------
// SnoopIPPacket
// ----------------------------------------------------------------------------
class SnoopIPPacket : public SnoopETHPacket
{
public:
  EXPORT_PROPERTY        (IP_HDR*, m_ipHdr, IP_HDR*, ipHdr)
  EXPORT_POINTER_PROPERTY(IP_HDR*, m_ipHdr, IP_HDR*, p_ipHdr)
};
*/
// ----------------------------------

// ----------------------------------------------------------------------------
// SnoopIP
// ----------------------------------------------------------------------------
class SnoopIP
{
public:
  static bool   is    (IP_HDR* ipHdr, UINT8 protocol, void** transportHdr);
  static bool   isTCP (IP_HDR* ipHdr, TCP_HDR**  tcpHdr);
  static bool   isUDP (IP_HDR* ipHdr, UDP_HDR**  udpHdr);
  static bool   isICMP(IP_HDR* ipHdr, ICMP_HDR** icmpHdr);
  static UINT16 checksum(IP_HDR* ipHdr);
  static UINT16 recalculateChecksum(UINT16 oldChecksum, UINT16 oldValue, UINT16 newValue);

public:
  static bool   parse(SnoopPacket* packet);
};

#endif  SnoopIPH