// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopNetInfoH
#define SnoopNetInfoH

#include "SnoopAdapterInfo.h"
#include "Snoop.h"

// ----------------------------------------------------------------------------
// SnoopNetInfo
// ----------------------------------------------------------------------------
class SnoopNetInfo : public IVDXMLable
{
  void* owner;
  int   m_adapterIndex;
public:
  SnoopNetInfo(void* owner = NULL);
  virtual ~SnoopNetInfo();
  void clear();

public:
  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  int  getAdapterIndex();
  virtual void setAdapterIndex(int value);

public:
  IP  ip;
  MAC mac;
  IP  subnetMask;
  IP  gateway;
  IP  startIP;
  IP  endIP;

protected:
  IP   ip_and_subnetMask; // for isSameLanIP
public:
  bool isSameLanIP(IP ip) { return (ip_and_subnetMask) == (ip & subnetMask); }
  IP   getAdjIP(IP ip)    { return isSameLanIP(ip) ? ip : gateway; }

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  SnoopNetInfoH