// ----------------------------------------------------------------------------
//
// SnoopPcap Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopPCapH
#define SnoopPCapH

#include "SnoopCapture.h"

// ----------------------------------------------------------------------------
// SnoopPcap
// ----------------------------------------------------------------------------
class SnoopPcap : public SnoopCapture
{
public:
  SnoopPcap(void* owner = NULL);
  virtual ~SnoopPcap();

protected:
  virtual bool doOpen();
  virtual bool doClose();

public:
  virtual int read(SnoopPacket* packet);
  virtual int write(char* buf, int size);

public:
  virtual int captureType() { return SCT_OUT_OF_PATH; }
  virtual int relay(SnoopPacket* packet);

  //
  // Properties
  //
public:
  string       filter;
  int          snapLen;
  int          flags;
  int          readTimeout;

public:
  pcap*        m_pcap;
protected:
  int          m_dataLink;
  string       m_sourceName;

public:
  EXPORT_READ_PROPERTY(int, m_dataLink, int, dataLink)
  EXPORT_READ_PROPERTY(string, m_sourceName, string, sourceName)

protected:
  bool pcapOpen(char* source, pcap_rmtauth* auth, pcap_if_t* dev);
  bool pcapProcessFilter(pcap_if_t* dev);

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  SnoopPCapH