// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopRemoteH
#define SnoopRemoteH

#include "SnoopPcap.h"
#include "SnoopAdapterInfo.h"

// ----------------------------------------------------------------------------
// SnoopRemote event
// ----------------------------------------------------------------------------
class SnoopRemote;
typedef void (*SnoopRemote_OnGetAdapterInfo)(
  SnoopRemote*       scRemote,
  SnoopAdaptersInfo* adaptersInfo,
  int*               adapterIndex);

// ----------------------------------------------------------------------------
// SnoopRemote
// ----------------------------------------------------------------------------
class SnoopRemote : public SnoopPcap
{
public:
  SnoopRemote(void* owner = NULL);
  virtual ~SnoopRemote();

protected:
  virtual bool doOpen();
  virtual bool doClose();

public:
  string host;
  string userName;
  string password;
  int    adapterIndex;

protected:
  SnoopAdaptersInfo* adaptersInfo;
public:
  SnoopRemote_OnGetAdapterInfo onGetAdapterInfo;

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  SnoopRemoteH