// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopTypeKeyH
#define SnoopTypeKeyH

#include "SnoopType.h"

// ----------------------------------------------------------------------------
// SnoopMacKey
// ----------------------------------------------------------------------------
class SnoopMacKey
{
public:
  MAC mac;

  bool operator < (const SnoopMacKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopMacFlowKey
// ----------------------------------------------------------------------------
class SnoopMacFlowKey
{
public:
  MAC src_mac;
  MAC dst_mac;

  bool operator < (const SnoopMacFlowKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopMacSessionKey
// ----------------------------------------------------------------------------
class SnoopMacSessionKey
{
public:
  MAC mac_1;
  MAC mac_2;

  bool operator < (const SnoopMacSessionKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopIPKey
// ----------------------------------------------------------------------------
class SnoopIPKey
{
public:
  IP ip;

  bool operator < (const SnoopIPKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopIPFlowKey
// ----------------------------------------------------------------------------
class SnoopIPFlowKey
{
public:
  IP src_ip;
  IP dst_ip;

  bool operator < (const SnoopIPFlowKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopIPSessionKey
// ----------------------------------------------------------------------------
class SnoopIPSessionKey
{
public:
  IP ip_1;
  IP ip_2;

  bool operator < (const SnoopIPSessionKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopPortKey
// ----------------------------------------------------------------------------
class SnoopPortKey
{
public:
  int port;

  bool operator < (const SnoopPortKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopPortFlowKey
// ----------------------------------------------------------------------------
class SnoopPortFlowKey
{
public:
  int src_port;
  int dst_port;

  bool operator < (const SnoopPortFlowKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopPortSessionKey
// ----------------------------------------------------------------------------
class SnoopPortSessionKey
{
public:
  int port_1;
  int port_2;

  bool operator < (const SnoopPortSessionKey& rhs) const;
};

// ----------------------------------------------------------------------------
// SnoopTransportKey
// ----------------------------------------------------------------------------
class SnoopTransportKey
{
public:
  IP  ip;
  int port;

  bool operator < (const SnoopTransportKey& rhs) const;
};

typedef SnoopTransportKey SnoopTCPKey;
typedef SnoopTransportKey SnoopUDPKey;

// ----------------------------------------------------------------------------
// SnoopTransportFlowKey
// ----------------------------------------------------------------------------
class SnoopTransportFlowKey
{
public:
  IP  src_ip;
  int src_port;
  IP  dst_ip;
  int dst_port;

  bool operator < (const SnoopTransportFlowKey& rhs) const;
};

typedef SnoopTransportFlowKey SnoopTCPFlowKey;
typedef SnoopTransportFlowKey SnoopUDPFlowKey;

// ----------------------------------------------------------------------------
// SnoopTransportSessionKey
// ----------------------------------------------------------------------------
class SnoopTransportSessionKey
{
public:
  IP  ip_1;
  int port_1;
  IP  ip_2;
  int port_2;

  bool operator < (const SnoopTransportSessionKey& rhs) const;
};

typedef SnoopTransportSessionKey SnoopTCPSessionKey;
typedef SnoopTransportSessionKey SnoopUDPSessionKey;

#endif  SnoopTypeKeyH