// ----------------------------------------------------------------------------
//
// Snoop Component Suite version 5.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef SnoopVirtualSwitchH
#define SnoopVirtualSwitchH

#include "SnoopAdapter.h"
#include "SnoopNetInfo.h"

// ----------------------------------------------------------------------------
// SnoopVirtualSwitch
// ----------------------------------------------------------------------------
class SnoopVirtualSwitch : SnoopCapture
{
public:
  SnoopVirtualSwitch(void* owner = NULL);
  virtual ~SnoopVirtualSwitch();

protected:
  virtual bool doOpen();
  virtual bool doClose();

protected:
	int m_virtualAdapterIndex;
	int m_readAdapterIndex;
public:
  __declspec(property (get=getVirtualAdapterIndex, put=setVirtualAdapterIndex)) int virtualAdapterIndex;
  int          getVirtualAdapterIndex() { return m_virtualAdapterIndex; }
  virtual void setVirtualAdapterIndex(int value);
  __declspec(property (get=getRealAdapterIndex, put=setRealAdapterIndex)) int readAdapterIndex;
  int          getRealAdapterIndex() { return m_readAdapterIndex; }
  virtual void setRealAdapterIndex(int value);

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif // SnoopVirtualSwitchH
